/* DeviceRow.c generated by valac 0.56.17, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "bluetooth.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];
typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED
} BluetoothDeviceRowStatus;

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL,
	BLUETOOTH_DEVICE_ROW_NUM_SIGNALS
};
static guint bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkButton* forget_button;
	GtkImage* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	BluetoothServicesDevice* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	BluetoothServicesDevice* _tmp9_;
	GError* _vala1_e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	BluetoothServicesDevice* _tmp12_;
	GError* _vala2_e;
	GtkImage* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static GType bluetooth_device_row_get_type_once (void);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}

static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result;
	switch (self) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Available"));
			result = _tmp0_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Pairing…"));
			result = _tmp1_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Connected"));
			result = _tmp2_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Connecting…"));
			result = _tmp3_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
			result = _tmp4_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Unable to Connect"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Not Connected"));
			result = _tmp6_;
			return result;
		}
	}
}

static GType
bluetooth_device_row_status_get_type_once (void)
{
	static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED", "unable-to-connect-paired"}, {0, NULL, NULL}};
	GType bluetooth_device_row_status_type_id;
	bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
	return bluetooth_device_row_status_type_id;
}

static GType
bluetooth_device_row_status_get_type (void)
{
	static volatile gsize bluetooth_device_row_status_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__once)) {
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = bluetooth_device_row_status_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_status_type_id__once, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__once;
}

BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (adapter != NULL, NULL);
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
	return self;
}

BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
}

static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_device;
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (!_data_->_tmp2_) {
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
		{
			_data_->_tmp3_ = _data_->self->priv->_device;
			_data_->_state_ = 1;
			bluetooth_services_device_pair (_data_->_tmp3_, bluetooth_device_row_button_clicked_ready, _data_);
			return FALSE;
			_state_1:
			bluetooth_services_device_pair_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
			_data_->_tmp4_ = _data_->e;
			_data_->_tmp5_ = _data_->_tmp4_->message;
			g_critical ("DeviceRow.vala:248: %s", _data_->_tmp5_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->_tmp6_ = _data_->self->priv->_device;
		_data_->_tmp7_ = bluetooth_services_device_get_connected (_data_->_tmp6_);
		_data_->_tmp8_ = _data_->_tmp7_;
		if (!_data_->_tmp8_) {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
			{
				_data_->_tmp9_ = _data_->self->priv->_device;
				_data_->_state_ = 2;
				bluetooth_services_device_connect (_data_->_tmp9_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_2:
				bluetooth_services_device_connect_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				_data_->_vala1_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED);
				_data_->_tmp10_ = _data_->_vala1_e;
				_data_->_tmp11_ = _data_->_tmp10_->message;
				g_critical ("DeviceRow.vala:256: %s", _data_->_tmp11_);
				_g_error_free0 (_data_->_vala1_e);
			}
			__finally1:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		} else {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
			{
				_data_->_tmp12_ = _data_->self->priv->_device;
				_data_->_state_ = 3;
				bluetooth_services_device_disconnect (_data_->_tmp12_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_3:
				bluetooth_services_device_disconnect_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				_data_->_vala2_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				_data_->_tmp13_ = _data_->self->priv->state;
				g_object_set (_data_->_tmp13_, "icon-name", "user-busy", NULL);
				_data_->_tmp14_ = _data_->_vala2_e;
				_data_->_tmp15_ = _data_->_tmp14_->message;
				g_critical ("DeviceRow.vala:264: %s", _data_->_tmp15_);
				_g_error_free0 (_data_->_vala2_e);
			}
			__finally2:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->_device;
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
		} else {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
		}
	}
}

static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkImage* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state_label;
	_tmp1_ = bluetooth_device_row_status_to_string (status);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp5_ = self->priv->state;
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
	switch (status) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			GtkButton* _tmp6_;
			GtkButton* _tmp7_;
			GtkLinkButton* _tmp8_;
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			_tmp6_ = self->priv->connect_button;
			gtk_button_set_label (_tmp6_, _ ("Pair"));
			_tmp7_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
			_tmp8_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
			_tmp9_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
			_tmp10_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			GtkButton* _tmp11_;
			GtkImage* _tmp12_;
			GtkLinkButton* _tmp13_;
			GtkButton* _tmp14_;
			_tmp11_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
			_tmp12_ = self->priv->state;
			g_object_set (_tmp12_, "icon-name", "emblem-mixed", NULL);
			_tmp13_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
			_tmp14_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			GtkButton* _tmp15_;
			GtkButton* _tmp16_;
			GtkImage* _tmp17_;
			GtkLinkButton* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			GtkButton* _tmp22_;
			GtkButton* _tmp23_;
			_tmp15_ = self->priv->connect_button;
			gtk_button_set_label (_tmp15_, _ ("Disconnect"));
			_tmp16_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, TRUE);
			_tmp17_ = self->priv->state;
			g_object_set (_tmp17_, "icon-name", "emblem-enabled", NULL);
			_tmp18_ = self->priv->settings_button;
			_tmp19_ = gtk_link_button_get_uri (_tmp18_);
			_tmp20_ = _tmp19_;
			if (g_strcmp0 (_tmp20_, "") != 0) {
				GtkLinkButton* _tmp21_;
				_tmp21_ = self->priv->settings_button;
				gtk_widget_set_visible ((GtkWidget*) _tmp21_, TRUE);
			}
			_tmp22_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, TRUE);
			_tmp23_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp23_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			GtkButton* _tmp24_;
			GtkImage* _tmp25_;
			GtkLinkButton* _tmp26_;
			GtkButton* _tmp27_;
			GtkButton* _tmp28_;
			_tmp24_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, FALSE);
			_tmp25_ = self->priv->state;
			g_object_set (_tmp25_, "icon-name", "emblem-mixed", NULL);
			_tmp26_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp26_, FALSE);
			_tmp27_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp27_, FALSE);
			_tmp28_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp28_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			GtkButton* _tmp29_;
			GtkImage* _tmp30_;
			GtkLinkButton* _tmp31_;
			GtkButton* _tmp32_;
			GtkButton* _tmp33_;
			_tmp29_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp29_, FALSE);
			_tmp30_ = self->priv->state;
			g_object_set (_tmp30_, "icon-name", "emblem-mixed", NULL);
			_tmp31_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
			_tmp32_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp32_, FALSE);
			_tmp33_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp33_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
		{
			GtkButton* _tmp34_;
			GtkButton* _tmp35_;
			GtkImage* _tmp36_;
			GtkLinkButton* _tmp37_;
			GtkButton* _tmp38_;
			GtkButton* _tmp39_;
			_tmp34_ = self->priv->connect_button;
			gtk_button_set_label (_tmp34_, _ ("Connect"));
			_tmp35_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp35_, TRUE);
			_tmp36_ = self->priv->state;
			g_object_set (_tmp36_, "icon-name", "emblem-disabled", NULL);
			_tmp37_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp37_, FALSE);
			_tmp38_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp38_, TRUE);
			_tmp39_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		{
			GtkButton* _tmp40_;
			GtkImage* _tmp41_;
			GtkLinkButton* _tmp42_;
			GtkButton* _tmp43_;
			_tmp40_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, TRUE);
			_tmp41_ = self->priv->state;
			g_object_set (_tmp41_, "icon-name", "emblem-error", NULL);
			_tmp42_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp42_, FALSE);
			_tmp43_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp43_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			GtkButton* _tmp44_;
			GtkImage* _tmp45_;
			GtkLinkButton* _tmp46_;
			GtkButton* _tmp47_;
			GtkButton* _tmp48_;
			_tmp44_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp44_, TRUE);
			_tmp45_ = self->priv->state;
			g_object_set (_tmp45_, "icon-name", "emblem-error", NULL);
			_tmp46_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp46_, FALSE);
			_tmp47_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp47_, TRUE);
			_tmp48_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp48_, TRUE);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL], 0);
}

BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
	BluetoothServicesDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_device (self);
	if (old_value != value) {
		BluetoothServicesDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
	}
}

BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_adapter;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
	BluetoothServicesAdapter* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_adapter (self);
	if (old_value != value) {
		self->priv->_adapter = value;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		BluetoothDeviceRow* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->label);
		_g_object_unref0 (_data1_->image);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_bluetooth_device_row___lambda23_ (BluetoothDeviceRow* self,
                                   GVariant* changed,
                                   gchar** invalid)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	powered = _tmp3_;
	_tmp4_ = powered;
	if (_tmp4_ != NULL) {
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_adapter;
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_g_variant_unref0 (powered);
}

static void
__bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda23_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda24_ (Block1Data* _data1_,
                                   GVariant* changed,
                                   gchar** invalid)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* name = NULL;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* icon = NULL;
	GVariantType* _tmp21_;
	GVariantType* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	self = _data1_->self;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	paired = _tmp3_;
	_tmp4_ = paired;
	if (_tmp4_ != NULL) {
		BluetoothServicesDevice* _tmp5_;
		bluetooth_device_row_compute_status (self);
		_tmp5_ = self->priv->_device;
		bluetooth_services_device_connect (_tmp5_, NULL, NULL);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp6_ = g_variant_type_new ("b");
	_tmp7_ = _tmp6_;
	_tmp8_ = g_variant_lookup_value (changed, "Connected", _tmp7_);
	_tmp9_ = _tmp8_;
	_g_variant_type_free0 (_tmp7_);
	connected = _tmp9_;
	_tmp10_ = connected;
	if (_tmp10_ != NULL) {
		bluetooth_device_row_compute_status (self);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp11_ = g_variant_type_new ("s");
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_lookup_value (changed, "Name", _tmp12_);
	_tmp14_ = _tmp13_;
	_g_variant_type_free0 (_tmp12_);
	name = _tmp14_;
	_tmp15_ = name;
	if (_tmp15_ != NULL) {
		GtkLabel* _tmp16_;
		BluetoothServicesDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp16_ = _data1_->label;
		_tmp17_ = self->priv->_device;
		_tmp18_ = bluetooth_services_device_get_name (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_;
		gtk_label_set_label (_tmp16_, _tmp20_);
		_g_free0 (_tmp20_);
	}
	_tmp21_ = g_variant_type_new ("s");
	_tmp22_ = _tmp21_;
	_tmp23_ = g_variant_lookup_value (changed, "Icon", _tmp22_);
	_tmp24_ = _tmp23_;
	_g_variant_type_free0 (_tmp22_);
	icon = _tmp24_;
	_tmp25_ = icon;
	if (_tmp25_ != NULL) {
		gchar* _tmp26_ = NULL;
		BluetoothServicesDevice* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		GtkImage* _tmp31_;
		_tmp27_ = self->priv->_device;
		_tmp28_ = bluetooth_services_device_get_icon (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp26_ = _tmp29_;
		if (_tmp26_ == NULL) {
			gchar* _tmp30_;
			_tmp30_ = g_strdup ("bluetooth");
			_g_free0 (_tmp26_);
			_tmp26_ = _tmp30_;
		}
		_tmp31_ = _data1_->image;
		g_object_set (_tmp31_, "icon-name", _tmp26_, NULL);
		_g_free0 (_tmp26_);
	}
	_g_variant_unref0 (icon);
	_g_variant_unref0 (name);
	_g_variant_unref0 (connected);
	_g_variant_unref0 (paired);
}

static void
__bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda24_ (self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda25_ (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	bluetooth_device_row_button_clicked (self, NULL, NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_paired (_tmp1_);
	_tmp3_ = _tmp2_;
	bluetooth_services_device_set_trusted (_tmp0_, _tmp3_);
}

static void
__bluetooth_device_row___lambda25__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda25_ ((BluetoothDeviceRow*) self);
}

static void
_bluetooth_device_row___lambda26_ (BluetoothDeviceRow* self)
{
	GError* _inner_error0_ = NULL;
	{
		BluetoothServicesAdapter* _tmp0_;
		BluetoothServicesDevice* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
		_tmp0_ = self->priv->_adapter;
		_tmp1_ = self->priv->_device;
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_dbus_proxy_get_type (), GDBusProxy), "g-object-path", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = _tmp5_;
		bluetooth_services_adapter_remove_device (_tmp0_, _tmp6_, &_inner_error0_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_debug ("DeviceRow.vala:235: Forget bluetooth device failed: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__bluetooth_device_row___lambda26__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda26_ ((BluetoothDeviceRow*) self);
}

static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block1Data* _data1_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkImage* _tmp5_ = NULL;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* overlay = NULL;
	GtkImage* _tmp12_;
	GtkWidget* _tmp13_;
	BluetoothServicesDevice* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkOverlay* _tmp17_ = NULL;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	gchar* device_name = NULL;
	BluetoothServicesDevice* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkImage* _tmp53_;
	GtkLinkButton* _tmp54_ = NULL;
	gchar* _tmp55_;
	GtkButton* _tmp56_ = NULL;
	GtkButton* _tmp57_ = NULL;
	GtkSizeGroup* _tmp58_;
	GtkButton* _tmp59_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp60_ = NULL;
	GtkGrid* _tmp61_;
	GtkOverlay* _tmp62_;
	GtkGrid* _tmp63_;
	GtkLabel* _tmp64_;
	GtkGrid* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkLinkButton* _tmp68_;
	GtkGrid* _tmp69_;
	GtkButton* _tmp70_;
	GtkGrid* _tmp71_;
	GtkButton* _tmp72_;
	GtkGrid* _tmp73_;
	BluetoothServicesDevice* _tmp74_;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	GQuark _tmp79_ = 0U;
	static GQuark _tmp78_label0 = 0;
	static GQuark _tmp78_label1 = 0;
	static GQuark _tmp78_label2 = 0;
	static GQuark _tmp78_label3 = 0;
	static GQuark _tmp78_label4 = 0;
	static GQuark _tmp78_label5 = 0;
	static GQuark _tmp78_label6 = 0;
	BluetoothServicesAdapter* _tmp90_;
	gboolean _tmp91_;
	gboolean _tmp92_;
	BluetoothServicesAdapter* _tmp93_;
	BluetoothServicesDevice* _tmp94_;
	GtkButton* _tmp95_;
	GtkButton* _tmp96_;
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("bluetooth");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	}
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_);
	gtk_image_set_pixel_size (_tmp5_, 32);
	g_object_ref_sink (_tmp5_);
	_data1_->image = _tmp5_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-disabled");
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp6_;
	_tmp7_ = self->priv->state;
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
	_tmp8_ = self->priv->state;
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp9_;
	_tmp10_ = self->priv->state_label;
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = self->priv->state_label;
	gtk_label_set_use_markup (_tmp11_, TRUE);
	_tmp12_ = _data1_->image;
	_tmp13_ = _g_object_ref0 ((GtkWidget*) _tmp12_);
	_tmp14_ = self->priv->_device;
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = (GtkOverlay*) gtk_overlay_new ();
	gtk_overlay_set_child (_tmp17_, _tmp13_);
	_g_object_unref0 (_tmp13_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp17_, _tmp16_);
	_g_free0 (_tmp16_);
	g_object_ref_sink (_tmp17_);
	overlay = _tmp17_;
	_tmp18_ = overlay;
	_tmp19_ = self->priv->state;
	gtk_overlay_add_overlay (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->_device;
	_tmp21_ = bluetooth_services_device_get_name (_tmp20_);
	_tmp22_ = _tmp21_;
	device_name = _tmp22_;
	_tmp23_ = device_name;
	if (_tmp23_ == NULL) {
		BluetoothServicesDevice* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gboolean _tmp28_;
		_tmp24_ = self->priv->_device;
		_tmp25_ = bluetooth_services_device_get_icon (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = _tmp26_;
		_tmp28_ = _tmp27_ != NULL;
		_g_free0 (_tmp27_);
		if (_tmp28_) {
			BluetoothServicesDevice* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			GQuark _tmp34_ = 0U;
			static GQuark _tmp33_label0 = 0;
			static GQuark _tmp33_label1 = 0;
			static GQuark _tmp33_label2 = 0;
			static GQuark _tmp33_label3 = 0;
			static GQuark _tmp33_label4 = 0;
			static GQuark _tmp33_label5 = 0;
			static GQuark _tmp33_label6 = 0;
			_tmp29_ = self->priv->_device;
			_tmp30_ = bluetooth_services_device_get_icon (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp32_ = _tmp31_;
			_tmp34_ = (NULL == _tmp32_) ? 0 : g_quark_from_string (_tmp32_);
			g_free (_tmp32_);
			if (_tmp34_ == ((0 != _tmp33_label0) ? _tmp33_label0 : (_tmp33_label0 = g_quark_from_static_string ("audio-card")))) {
				switch (0) {
					default:
					{
						gchar* _tmp35_;
						_tmp35_ = g_strdup (_ ("Speaker"));
						_g_free0 (device_name);
						device_name = _tmp35_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label1) ? _tmp33_label1 : (_tmp33_label1 = g_quark_from_static_string ("input-gaming")))) {
				switch (0) {
					default:
					{
						gchar* _tmp36_;
						_tmp36_ = g_strdup (_ ("Controller"));
						_g_free0 (device_name);
						device_name = _tmp36_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label2) ? _tmp33_label2 : (_tmp33_label2 = g_quark_from_static_string ("input-keyboard")))) {
				switch (0) {
					default:
					{
						gchar* _tmp37_;
						_tmp37_ = g_strdup (_ ("Keyboard"));
						_g_free0 (device_name);
						device_name = _tmp37_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label3) ? _tmp33_label3 : (_tmp33_label3 = g_quark_from_static_string ("input-mouse")))) {
				switch (0) {
					default:
					{
						gchar* _tmp38_;
						_tmp38_ = g_strdup (_ ("Mouse"));
						_g_free0 (device_name);
						device_name = _tmp38_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label4) ? _tmp33_label4 : (_tmp33_label4 = g_quark_from_static_string ("input-tablet")))) {
				switch (0) {
					default:
					{
						gchar* _tmp39_;
						_tmp39_ = g_strdup (_ ("Tablet"));
						_g_free0 (device_name);
						device_name = _tmp39_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label5) ? _tmp33_label5 : (_tmp33_label5 = g_quark_from_static_string ("input-touchpad")))) {
				switch (0) {
					default:
					{
						gchar* _tmp40_;
						_tmp40_ = g_strdup (_ ("Touchpad"));
						_g_free0 (device_name);
						device_name = _tmp40_;
						break;
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label6) ? _tmp33_label6 : (_tmp33_label6 = g_quark_from_static_string ("phone")))) {
				switch (0) {
					default:
					{
						gchar* _tmp41_;
						_tmp41_ = g_strdup (_ ("Phone"));
						_g_free0 (device_name);
						device_name = _tmp41_;
						break;
					}
				}
			} else {
				switch (0) {
					default:
					{
						BluetoothServicesDevice* _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						_tmp42_ = self->priv->_device;
						_tmp43_ = bluetooth_services_device_get_address (_tmp42_);
						_tmp44_ = _tmp43_;
						_g_free0 (device_name);
						device_name = _tmp44_;
					}
				}
			}
		} else {
			BluetoothServicesDevice* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			_tmp45_ = self->priv->_device;
			_tmp46_ = bluetooth_services_device_get_address (_tmp45_);
			_tmp47_ = _tmp46_;
			_g_free0 (device_name);
			device_name = _tmp47_;
		}
	}
	_tmp48_ = device_name;
	_tmp49_ = (GtkLabel*) gtk_label_new (_tmp48_);
	g_object_ref_sink (_tmp49_);
	_data1_->label = _tmp49_;
	_tmp50_ = _data1_->label;
	gtk_label_set_ellipsize (_tmp50_, PANGO_ELLIPSIZE_END);
	_tmp51_ = _data1_->label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp51_, TRUE);
	_tmp52_ = _data1_->label;
	gtk_label_set_xalign (_tmp52_, (gfloat) 0);
	_tmp53_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic");
	g_object_ref_sink (_tmp53_);
	_tmp54_ = (GtkLinkButton*) gtk_link_button_new ("");
	gtk_button_set_child ((GtkButton*) _tmp54_, (GtkWidget*) _tmp53_);
	_g_object_unref0 (_tmp53_);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp54_, 3);
	gtk_widget_set_valign ((GtkWidget*) _tmp54_, GTK_ALIGN_CENTER);
	gtk_widget_set_visible ((GtkWidget*) _tmp54_, FALSE);
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (self->priv->settings_button);
	self->priv->settings_button = _tmp54_;
	_tmp55_ = g_strdup (_ ("Forget this device"));
	_tmp56_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic");
	gtk_button_set_has_frame (_tmp56_, FALSE);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp56_, 3);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp56_, _tmp55_);
	_g_free0 (_tmp55_);
	gtk_widget_set_valign ((GtkWidget*) _tmp56_, GTK_ALIGN_CENTER);
	gtk_widget_set_visible ((GtkWidget*) _tmp56_, FALSE);
	g_object_ref_sink (_tmp56_);
	_g_object_unref0 (self->priv->forget_button);
	self->priv->forget_button = _tmp56_;
	_tmp57_ = (GtkButton*) gtk_button_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp57_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->connect_button);
	self->priv->connect_button = _tmp57_;
	_tmp58_ = bluetooth_device_row_size_group;
	_tmp59_ = self->priv->connect_button;
	gtk_size_group_add_widget (_tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp60_, 6);
	g_object_ref_sink (_tmp60_);
	grid = _tmp60_;
	_tmp61_ = grid;
	_tmp62_ = overlay;
	gtk_grid_attach (_tmp61_, (GtkWidget*) _tmp62_, 0, 0, 1, 2);
	_tmp63_ = grid;
	_tmp64_ = _data1_->label;
	gtk_grid_attach (_tmp63_, (GtkWidget*) _tmp64_, 1, 0, 1, 1);
	_tmp65_ = grid;
	_tmp66_ = self->priv->state_label;
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 1, 1, 1, 1);
	_tmp67_ = grid;
	_tmp68_ = self->priv->settings_button;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 2, 0, 1, 2);
	_tmp69_ = grid;
	_tmp70_ = self->priv->forget_button;
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 3, 0, 1, 2);
	_tmp71_ = grid;
	_tmp72_ = self->priv->connect_button;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 4, 0, 1, 2);
	_tmp73_ = grid;
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp73_);
	_tmp74_ = self->priv->_device;
	_tmp75_ = bluetooth_services_device_get_icon (_tmp74_);
	_tmp76_ = _tmp75_;
	_tmp77_ = _tmp76_;
	_tmp79_ = (NULL == _tmp77_) ? 0 : g_quark_from_string (_tmp77_);
	g_free (_tmp77_);
	if (((_tmp79_ == ((0 != _tmp78_label0) ? _tmp78_label0 : (_tmp78_label0 = g_quark_from_static_string ("audio-card")))) || (_tmp79_ == ((0 != _tmp78_label1) ? _tmp78_label1 : (_tmp78_label1 = g_quark_from_static_string ("audio-headphones"))))) || (_tmp79_ == ((0 != _tmp78_label2) ? _tmp78_label2 : (_tmp78_label2 = g_quark_from_static_string ("audio-headset"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp80_;
				GtkLinkButton* _tmp81_;
				_tmp80_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp80_, "settings://sound");
				_tmp81_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp81_, _ ("Sound Settings"));
				break;
			}
		}
	} else if ((_tmp79_ == ((0 != _tmp78_label3) ? _tmp78_label3 : (_tmp78_label3 = g_quark_from_static_string ("input-gaming")))) || (_tmp79_ == ((0 != _tmp78_label4) ? _tmp78_label4 : (_tmp78_label4 = g_quark_from_static_string ("input-keyboard"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp82_;
				GtkLinkButton* _tmp83_;
				_tmp82_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp82_, "settings://input/keyboard");
				_tmp83_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp83_, _ ("Keyboard Settings"));
				break;
			}
		}
	} else if (_tmp79_ == ((0 != _tmp78_label5) ? _tmp78_label5 : (_tmp78_label5 = g_quark_from_static_string ("input-mouse")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp84_;
				GtkLinkButton* _tmp85_;
				_tmp84_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp84_, "settings://input/pointer/mouse");
				_tmp85_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp85_, _ ("Mouse & Touchpad Settings"));
				break;
			}
		}
	} else if (_tmp79_ == ((0 != _tmp78_label6) ? _tmp78_label6 : (_tmp78_label6 = g_quark_from_static_string ("printer")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp86_;
				GtkLinkButton* _tmp87_;
				_tmp86_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp86_, "settings://printer");
				_tmp87_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp87_, _ ("Printer Settings"));
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp88_;
				GtkLinkButton* _tmp89_;
				_tmp88_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp88_, "");
				_tmp89_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp89_, NULL);
				break;
			}
		}
	}
	bluetooth_device_row_compute_status (self);
	_tmp90_ = self->priv->_adapter;
	_tmp91_ = bluetooth_services_adapter_get_powered (_tmp90_);
	_tmp92_ = _tmp91_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp92_);
	_tmp93_ = self->priv->_adapter;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda23__g_dbus_proxy_g_properties_changed, self, 0);
	_tmp94_ = self->priv->_device;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp94_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda24__g_dbus_proxy_g_properties_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp95_ = self->priv->connect_button;
	g_signal_connect_object (_tmp95_, "clicked", (GCallback) __bluetooth_device_row___lambda25__gtk_button_clicked, self, 0);
	_tmp96_ = self->priv->forget_button;
	g_signal_connect_object (_tmp96_, "clicked", (GCallback) __bluetooth_device_row___lambda26__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_free0 (device_name);
	_g_object_unref0 (overlay);
	_g_free0 (_tmp0_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return obj;
}

static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass,
                                 gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL] = g_signal_new ("status-changed", BLUETOOTH_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (bluetooth_device_row_size_group);
	bluetooth_device_row_size_group = _tmp0_;
}

static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self,
                                    gpointer klass)
{
	self->priv = bluetooth_device_row_get_instance_private (self);
}

static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->connect_button);
	_g_object_unref0 (self->priv->forget_button);
	_g_object_unref0 (self->priv->state);
	_g_object_unref0 (self->priv->state_label);
	_g_object_unref0 (self->priv->settings_button);
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
}

static GType
bluetooth_device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
	GType bluetooth_device_row_type_id;
	bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
	BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
	return bluetooth_device_row_type_id;
}

GType
bluetooth_device_row_get_type (void)
{
	static volatile gsize bluetooth_device_row_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__once)) {
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = bluetooth_device_row_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_type_id__once, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__once;
}

static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_device (self));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		bluetooth_device_row_set_device (self, g_value_get_object (value));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

